#ifndef _PAIRS_H
#define _PAIRS_H

#ifdef __cplusplus
extern "C" {
#endif

#include <input.h>

struct ipair {
	input_t prev;
	input_t next;
};

#ifdef __cplusplus
uint64_t chk_pair(const ipair* __restrict__ pair) __attribute__((pure));
uint64_t sum_pairs(uint64_t length, const input_t input[const __restrict__ length]) __attribute__((pure));
}
#else
uint64_t chk_pair(const struct ipair* restrict pair) __attribute__((pure));
uint64_t sum_pairs(uint64_t length, const input_t input[const restrict length]) __attribute__((pure));
#endif

#endif /* _PAIRS_H */
