
#include <input.h>

#include <pairs.h>

__attribute__((pure))
uint64_t chk_pair(const struct ipair* restrict pair)
{
	return pair->prev < pair->next;
}

__attribute__((pure))
uint64_t sum_pairs(uint64_t length, const input_t input[const restrict length])
{
	uint64_t res = 0;
	for(size_t i=0;i<length-1;i++)
	{
		res += chk_pair((const struct ipair*)(input+i));
	}
	return res;
}

int part1(uint64_t* restrict _res)
{
	*_res = sum_pairs(INPUT_SIZE, INPUT);
	return 0;
}
