#include <input.h>

#include <pairs.h>

struct window {
	input_t pre, cur, suc;
};

__attribute__((pure))
inline static input_t sum_window(const struct window* restrict w)
{
	return w->pre + w->cur + w->suc;
}

int part2(uint64_t* restrict _res)
{
	uint64_t res=0;

	for(size_t i=0;i<INPUT_SIZE-2;i++)
	{
		struct ipair w6;
		w6.prev = sum_window((const struct window*)(INPUT+i));
		w6.next = sum_window((const struct window*)(INPUT+i+1));
		
		res += (w6.prev < w6.next);
	}

	*_res = res;
	return 0;
}
